/***************************************************************************
 *   Copyright (C) 2004 by Claudio Attaccalite                             *
 *   claudio@freescience.info                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#ifndef MyBlas
#define MyBlas myblas.h
#if HAVE_CONFIG
#include <config.h>
#endif

#include <iostream>
#include "DMatrix.h"
#include "DVector.h"
#include "SMatrix.h"
#include "SVector.h"
#include "ZMatrix.h"
#include "ZVector.h"

/************* Double precision Blas **************/


/** Matrix*Matrix product **/

void dgemm(const double alpha,DMatrix &A,DMatrix &B,const double beta,DMatrix &C);

/** Matrix*Matrix^T product **/

void dgemm_n_t(const double alpha,DMatrix &A,DMatrix &B,const double beta,DMatrix &C);

/** Matrix^T*Matrix^T product **/

void dgemm_t_t(const double alpha,DMatrix &A,DMatrix &B,const double beta,DMatrix &C);

/** Matrix^T*Matrix product **/

void dgemm_t_n(const double alpha,DMatrix &A,DMatrix &B,const double beta,DMatrix &C);

/** Matrix*Vector product **/

void dgemv(double alpha,DMatrix &A,DVector &X,  double beta,DVector &Y);

/** Matrix^T*Vector product **/

void dgemv_t(double alpha,DMatrix &A,DVector &X, double beta,DVector &Y);

/********* Single Precision BLAS **********/

/** Matrix*Matrix product **/

void sgemm(const float alpha,SMatrix &A,SMatrix &B,const float beta,SMatrix &C);

/** Matrix*Matrix^T product **/

void sgemm_n_t(const float alpha,SMatrix &A,SMatrix &B,const float beta,SMatrix &C);

/** Matrix^T*Matrix^T product **/

void sgemm_t_t(const float alpha,SMatrix &A,SMatrix &B,const float beta,SMatrix &C);

/** Matrix^T*Matrix product **/

void sgemm_t_n(const float alpha,SMatrix &A,SMatrix &B,const float beta,SMatrix &C);

/** Matrix*Vector product **/

void sgemv(const float alpha,SMatrix &A,SVector &X, const float beta,SVector &Y);

/** Matrix^T*Vector product **/

void sgemv_t(const float alpha,SMatrix &A,SVector &X, const float beta,SVector &Y);


/***************** Complex BLAS ***********************/
/** Matrix*Vector product **/

void zgemv(complex<double> alpha,ZMatrix &A,ZVector &X,complex<double> beta,ZVector &Y);

void zgemv_t(complex<double> alpha,ZMatrix &A,ZVector &X,complex<double> beta,ZVector &Y);

void zgemv_c(complex<double> alpha,ZMatrix &A,ZVector &X,complex<double> beta,ZVector &Y);


/** Matrix*Matrix product **/

void zgemm(const complex<double> alpha,ZMatrix &A,ZMatrix &B,const complex<double> beta,ZMatrix &C);

void zgemm_n_t(const complex<double> alpha,ZMatrix &A,ZMatrix &B,const complex<double> beta,ZMatrix &C);

void zgemm_t_t(const complex<double> alpha,ZMatrix &A,ZMatrix &B,const complex<double> beta,ZMatrix &C);

void zgemm_t_n(const complex<double> alpha,ZMatrix &A,ZMatrix &B,const complex<double> beta,ZMatrix &C);

void zgemm_n_c(const complex<double> alpha,ZMatrix &A,ZMatrix &B,const complex<double> beta,ZMatrix &C);

void zgemm_c_c(const complex<double> alpha,ZMatrix &A,ZMatrix &B,const complex<double> beta,ZMatrix &C);

void zgemm_c_n(const complex<double> alpha,ZMatrix &A,ZMatrix &B,const complex<double> beta,ZMatrix &C);

void zgemm_t_c(const complex<double> alpha,ZMatrix &A,ZMatrix &B,const complex<double> beta,ZMatrix &C);

void zgemm_c_t(const complex<double> alpha,ZMatrix &A,ZMatrix &B,const complex<double> beta,ZMatrix &C);

#endif
