/***************************************************************************
 *   Copyright (C) 2004 by Claudio Attaccalite                             *
 *   claudio@freescience.info                                              *
 *                                                                         *
 *   Original from Davide Ceresoli 					   *
 *   http://www.sissa.it/~ceresoli/					   *
 *									   *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef BlasWrapper_H
#define BlasWrapper_H

#include <iostream>
#include <math.h>
#include <complex>
#include <cmath>

using namespace std;

#ifndef __C_COMPLEX
	#define __C_COMPLEX
	typedef struct
	{
	  float re, im;
	} __c_complex;
	
	typedef struct
	{
	  double re, im;
	} __c_dcomplex;
#endif

complex<double> dcmplx(double r,double i);

#define F77_FUNC(x,y) x##_

extern "C" {
	double F77_FUNC(ddot,DDOT)(int*, double*, int*, double*, int*);

	void F77_FUNC(dcopy,DCOPY)(int*, double*, int*, double*, int*);

	void F77_FUNC(daxpy,DAXPY)(int*, double*, double*, int*, double*, int*);
	
	double F77_FUNC(dnrm2,DNRM2)(int*, double*, int*);
  
	int F77_FUNC(idamax,IDAMAX)(int*, double*, int*);
	
	double F77_FUNC(dasum,DASUM)(int*, double*, int*);
	
	void F77_FUNC(dscal,DSCAL)(int*, double*, double*, int*);
	
	void F77_FUNC(dgemm,DGEMM)(char *transa, char *transb, int *m, int *n,
		      		int *k,double *alpha, double *a, int *lda, 
				double *b, int *ldb, double *beta, double *c,
			       	int *ldc);
  
	void F77_FUNC(dgemv,DGEMV)(char *trans, int *m, int *n, double *alpha, 
				  double *a, int *lda, double *x, int *incx, 
				  double *beta, double *y, int *incy);

	float F77_FUNC(sasum,SASUM)(int*, float*, int*);
	
	float F77_FUNC(sdot,SDOT)(int*, float*, int*, float*, int*);

	void F77_FUNC(scopy,SCOPY)(int*, float*, int*, float*, int*);

	void F77_FUNC(saxpy,SAXPY)(int*, float*, float*, int*, float*, int*);
	
	float F77_FUNC(snrm2,SNRM2)(int*, float*, int*);
	
	float F77_FUNC(sasum,SASUM)(int*, float*, int*);
	
	int F77_FUNC(isamax,ISAMAX)(int*, float*, int*);
	
	void F77_FUNC(sscal,SSCAL)(int*, float*, float*, int*);
	
	void F77_FUNC(sgemm,SGEMM)(char *transa, char *transb, int *m, int *n,
		      		int *k,float *alpha, float *a, int *lda, 
				float *b, int *ldb, float *beta, float *c,
			       	int *ldc);
  
	void F77_FUNC(sgemv,SGEMV)(char *trans, int *m, int *n, float *alpha, 
				  float *a, int *lda, float *x, int *incx, 
				  float *beta, float *y, int *incy);

  complex<double> F77_FUNC(zdotu,ZDOTU)(int*, double*, int*, double*, int*);
 
  complex<double> F77_FUNC(zdotc,ZDOTC)(int*, double*, int*, double*, int*);
  
  void F77_FUNC(zscal,ZSCAL)(int*, double*, double*, int*);
  
  void F77_FUNC(zaxpy,ZAXPY)(int*, double*, double*, int*, double*, int*);
  
  void F77_FUNC(zcopy,ZCOPY)(int*, double*, int*, double*, int*);
  
  double F77_FUNC(dznrm2,DZNRM2)(int*, double*, int*);
 
  double F77_FUNC(dzasum,DZASUM)(int*, double*, int*);
  
  int F77_FUNC(izamax,IZAMAX)(int*, double*, int*);
  
  void F77_FUNC(zgemm,ZGEMM)(char *transa, char *transb, int *m, int *n, int *k,    double *alpha, double *a, int *lda, double *b, int *ldb,
    double *beta, double *c, int *ldc);
  
  void F77_FUNC(zgemv,ZGEMV)(char *trans, int *m, int *n, double *alpha, 
     double *a, int *lda, double *x, int *incx, double *beta, 
     double *y, int *incy);

  void F77_FUNC(zgemm,ZGEMM)(char *transa, char *transb, int *m, int *n, int *k,
     double *alpha, double *a, int *lda, double *b, int *ldb, double *beta, 
     double *c, int *ldc);	
} 

#endif
