/***************************************************************************
 *   Copyright (C) 2004 by Claudio Attaccalite                             *
 *   claudio@freescience.info                                              *
 *									   *
 *   Original from Davide Ceresoli 					   *
 *   http://www.sissa.it/~ceresoli/					   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef LapackWrapper_H
#define LapackWrapper_H

#include <iostream>
#include <math.h>
#include <complex>

#define F77_FUNC(x,y) x##_

extern "C" {
	
  /** Double Precision **/
	
  void F77_FUNC(dsyev,DSYEV)(char *jobz, char *uplo, int *n, double *a, 
    int *lda, double *w, double *work, int *lwork, int *info);

  void F77_FUNC(dgetrf,DGETRF)(int *n, int *m, double *a, int *lda, int *ipiv,
    int *info);
    
  void F77_FUNC(dgetri,DGETRI)(int *n, double *a, int *lda, int *ipiv, 
    double *work, int *lwork, int *info);

  void F77_FUNC(dgetrs,DGETRS)(char *trans, int *n, int *nhrs, double *a, 
    int *lda, int *ipiv, double *b, int *ldb, int *info);

  /** Single Precision **/
  
  void F77_FUNC(ssyev,SSYEV)(char *jobz, char *uplo, int *n, float *a, 
    int *lda, float *w, float *work, int *lwork, int *info);

  void F77_FUNC(sgetrf,SGETRF)(int *n, int *m, float *a, int *lda, int *ipiv,
    int *info);
    
  void F77_FUNC(sgetri,SGETRI)(int *n, float *a, int *lda, int *ipiv, 
    float *work, int *lwork, int *info);

   void F77_FUNC(sgetrs,SGETRS)(char *trans, int *n, int *nhrs, float *a, 
    int *lda, int *ipiv, float *b, int *ldb, int *info);

}  

#endif
