#include<iostream>
#include"SMatrix.h"
#include"SVector.h"
#include"MyBlas.h"
#include"MyLapack.h"
#include"ZVector.h"
#include"ZMatrix.h"
#include<cmath>
#include<stdlib.h>

using namespace std;

int main()
{
int ndim=3,lwork;
int info;

SVector V2;
SMatrix M3;

V2.allocate(ndim);
M3.allocate(ndim,ndim);

float sum,*work;
int ipiv[3],ldx;

srand(1);


for(int i=0;i<ndim;i++) 
   for(int j=0;j<ndim;j++) 
	M3(j,i)=rand()/(float)RAND_MAX;

ldx=1;
lwork=ndim*ndim*ndim;
work= new float[lwork];

M3(0,0)=1;
M3(1,1)=5;
M3(2,2)=10;

info=SSYEV('n','u',M3,V2,work,lwork);

cout << " Eigenvalues " << V2 << endl;

cout << " * * * TEST COMPLEX VECTOR * * * " << endl;

ZVector Z1;
Z1.allocate(3);
Z1(0)=dcmplx(1,3);
Z1(1)=dcmplx(2.5,1.1);
Z1(2)=dcmplx(1.11,0.13);

cout << " Vector Z1: " << endl;
cout << Z1 << endl;

cout << " Norm " << Z1.Norm() << endl;

cout << " AbsoluteSum " << Z1.AbsoluteSum() << endl;

complex<double> zsum;
zsum=Z1.Sum();
cout << " Sum of the vector elements " << zsum << endl;

cout << " Element with the largest absolute value " <<  Z1.iMax() << endl;

ZVector Z2;
Z2.allocate(3);
cout << "\n Test ZCOPY " << endl;
cout << " Vector Z2: " << endl;
Z2=Z1;
cout << Z2 << endl;


double rconst=10;
cout << " Set all elements of Z2 to real " << rconst << endl;
Z2=rconst;
cout << Z2 << endl;
complex<double> cconst(10.5,4.5);
cout << " Set all elements  of Z2 to complex value " << cconst << endl;
Z2=cconst;
cout << Z2 << endl;

cout << " Z1 " << Z1 << endl;
cout << " Z2 " << Z2 << endl;
cout << " Z1 dotu Z2 " << Z1.zdotu(Z2) << endl;
cout << " Z1 dotc Z2 " << Z1.zdotc(Z2) << endl;

ZVector Z3(3);

Z3=Z1+Z2;
cout << " Z1 + Z2 = " << Z3 << endl;

Z3=Z1-Z2;
cout << " Z1 - Z2 = " << Z3 << endl;

cout << " Test Dscal for  " << cconst << endl;
Z1*=cconst;

cout << " new Z1 " << Z1 << endl;

cout << " * * * TEST COMPLEX MATRIX * * * " << endl;

ZMatrix M1(3,3);

for(int i=0;i<3;i++)
 for(int j=0;j<3;j++)	
	 M1(i,j)=dcmplx(i*2,j+i/(j+1));

cout << " M1 :\n" << M1 << endl;

ZMatrix M2(3,3);
cout << "\n Test ZCOPY " << endl;
M2=M1;
cout << " Matrix M2:\n"<< M2 << endl;

cout << " Set all elements  of M2 to real value " << rconst << endl;
M2=rconst;
cout << " Matrix M2:\n"<< M2 << endl;

cout << " Set all elements  of M2 to complex value " << cconst << endl;
M2=cconst;
cout << " Matrix M2:\n"<< M2 << endl;

cout << " Test Zscal for  " << cconst << endl;
M1*=cconst;
cout << " M1 :\n" << M1 << endl;

zsum=M1.SumAll();
cout << " Sum all matrix elements " << zsum << endl;

zsum=M1.Trace();
cout << " Trace of the matrix " << zsum << endl;

cout << "\n * * * Operation on rows and coloumns * * *" << endl;
cout << " Copy an 1D array into the 3rd row " <<  endl;
cout << " M1 Before :\n" << M1 << endl;
cout << " Vector  :\n" << Z1 << endl;
M1.setrow(2,Z1);
cout << " M1 After :\n" << M1 << endl;

cout << " Copy an 1D array into the 2nd col " <<  endl;
cout << " M1 Before :\n" << M1 << endl;
cout << " Vector  :\n" << Z1 << endl;
M1.setcol(1,Z1);
cout << " M1 After :\n" << M1 << endl;

cout << " Rescale a 2nd row for a given complex constant " <<  endl;
cout << " Constant  :\n" << cconst << endl;
M1.row_scale(1,cconst);
cout << " M1 After :\n" << M1 << endl;

cout << " ZDOT product between the 2nd row and a Vector Z1 " <<  endl;
cout << " M1.rowdotu :" << M1.rowdotu(1,Z1) << endl;

cout << " Copy  the first row in a vector " <<  endl;
Z1=M1.row(0);
cout << " Vector = :" << Z1 << endl;

cout << " Sum all elements of a row " <<  endl;
cout << " Sum row 1 = :" << M1.SumRow(0) << endl;

cout << " Sum of two matricex " <<  endl;
cout << " M1 + M2:\n" << M1+M2 << endl;

return(0);
}
